[inherit('common')]
module phttp;

type
   http = integer;

[external('VMS_HTTP_GET')]
function http_get(%STDESCR host : packed array [l1..u1:integer] of char;
                  %REF port : integer;
                  %STDESCR path : packed array [l2..u2:integer] of char;
                  %STDESCR acctyp : packed array [l3..u3:integer] of char) : http; extern;

[external('VMS_HTTP_POST')]
function http_post(%STDESCR host : packed array [l1..u1:integer] of char;
                   %REF port : integer;
                   %STDESCR path : packed array [l2..u2:integer] of char;
                   %STDESCR contyp : packed array [l3..u3:integer] of char;
                   %STDESCR acctyp : packed array [l4..u4:integer] of char;
                   %STDESCR body : packed array [l5..u5:integer] of char) : http; extern;

[external('VMS_HTTP_PUT')]
function http_put(%STDESCR host : packed array [l1..u1:integer] of char;
                  %REF port : integer;
                  %STDESCR path : packed array [l2..u2:integer] of char;
                  %STDESCR contyp : packed array [l3..u3:integer] of char;
                  %STDESCR body : packed array [l5..u5:integer] of char) : http; extern;

[external('VMS_HTTP_DELETE')]
function http_delete(%STDESCR host : packed array [l1..u1:integer] of char;
                     %REF port : integer;
                     %STDESCR path : packed array [l2..u2:integer] of char) : http; extern;

[external('VMS_HTTP_RECV')]
function http_recv(%REF con : http;
                   %STDESCR msg : packed array [l1..u1:integer] of char;
                   %REF msglen : word) : integer; extern;

[external('VMS_HTTP_RECV_ALL')]
function http_recv_all(%REF con : http;
                       %STDESCR msg : packed array [l1..u1:integer] of char;
                       %REF msglen : word) : integer; extern;

[external('VMS_HTTP_CLOSE')]
procedure http_close(%REF con : http); extern;

[external('VMS_HTTP_LENGTH')]
function http_length(%REF con : http) : integer; extern;

[external('VMS_HTTP_NUMCODE')]
function http_numcode(%REF con : http) : integer; extern;

[external('VMS_HTTP_TXTCODE')]
procedure http_txtcode(%REF con : http;
                       %STDESCR txtcode : packed array [l1..u1:integer] of char;
                       %REF txtcodelen : word); extern;

[external('VMS_HTTP_CONTYP')]
procedure http_contyp(%REF con : http;
                      %STDESCR contyp : packed array [l1..u1:integer] of char;
                      %REF contyplen : word); extern;

function http_txtcode2(con : http) : pstr;

var
   res : pstr;

begin
   http_txtcode(con, res.body, res.length);
   http_txtcode2 := res;
end;

function http_contyp2(con : http) : pstr;

var
   res : pstr;

begin
   http_contyp(con, res.body, res.length);
   http_contyp2 := res;
end;

end.
