#ifndef VMS_HTTP_H
#define VMS_HTTP_H

#include <descrip.h>

struct vms_http
{
   int sd;
   int numcode;
   char txtcode[1024];
   char contyp[256];
   int chunked;
   int length;
   int count;
};

struct vms_http *http_get(const char *host, int port, const char *path,
                          const char *acctyp);
struct vms_http *http_post(const char *host, int port, const char *path,
                           const char *contyp, const char *acctyp, const char *body);
struct vms_http *http_put(const char *host, int port, const char *path,
                          const char *contyp, const char *body);
struct vms_http *http_delete(const char *host, int port, const char *path);
int http_recv(struct vms_http *con, char *inmsg, int inmsgsiz, short int *inmsglen);
int http_recv_all(struct vms_http *con, char *inmsg, int inmsgsiz, short int *inmsglen);
void http_close(struct vms_http *con);
int http_length(struct vms_http *con);
int http_numcode(struct vms_http *con);
char *http_txtcode(struct vms_http *con);
char *http_contyp(struct vms_http *con);

struct vms_http *vms_http_get(struct dsc$descriptor *host, int *port, struct dsc$descriptor *path,
                              struct dsc$descriptor *acctyp);
struct vms_http *vms_http_post(struct dsc$descriptor *host, int *port, struct dsc$descriptor *path,
                               struct dsc$descriptor *contyp, struct dsc$descriptor *acctyp, struct dsc$descriptor *body);
struct vms_http *vms_http_put(struct dsc$descriptor *host, int *port, struct dsc$descriptor *path,
                              struct dsc$descriptor *contyp, struct dsc$descriptor *body);
struct vms_http *vms_http_delete(struct dsc$descriptor *host, int *port, struct dsc$descriptor *path);
int vms_http_recv(struct vms_http **con, struct dsc$descriptor *inmsg, short int *inmsglen);
int vms_http_recv_all(struct vms_http **con, struct dsc$descriptor *inmsg, short int *inmsglen);
void vms_http_close(struct vms_http **con);
int vms_http_length(struct vms_http **con);
int vms_http_numcode(struct vms_http **con);
void vms_http_txtcode(struct vms_http **con, struct dsc$descriptor *txtcode, short int *txtcodelen);
void vms_http_contyp(struct vms_http **con, struct dsc$descriptor *contyp, short int *contyplen);

#endif
